﻿@page "/travels"
@attribute [Authorize]

<h2>Add Travels</h2>
<SfSpinner @bind-Visible="IsLoading" Label="Fetching data..." />

<EditForm Model="@_travel" OnValidSubmit="SubmitTrip">
    <DataAnnotationsValidator />
    <div class="input-group mb-3">
        <SfDatePicker TValue="DateTime" @bind-Value="_travel.TravelDate"
                      Format="dd.MM.yyyy"
                      Placeholder="Travel date"
                      FloatLabelType="@FloatLabelType.Auto">
            <DatePickerEvents TValue="DateTime" ValueChange="ValueChangeHandler" />
        </SfDatePicker>
    </div>
    <div class="input-group mb-3">
        <SfCheckBox @ref="isLegCheck" HtmlAttributes="@legTripAttributes"
                    Label="Compute the leg of the current trip *" @bind-Checked="_travel.IsLeg" />
    </div>
    <div class="input-group mb-3">
        <SfNumericTextBox TValue="decimal?" @bind-Value="_travel.Distance"
                          Placeholder="Distance (km)"
                          FloatLabelType="@FloatLabelType.Auto">
            <ValidationMessage For="@(()=>_travel.Distance)" />
        </SfNumericTextBox>
    </div>
    <div class="input-group mb-3">
        <SfNumericTextBox TValue="decimal?" @bind-Value="_travel.Consumption"
                          Placeholder="Consumption (kWh/100km)"
                          FloatLabelType="@FloatLabelType.Auto">
            <ValidationMessage For="@(()=>_travel.Consumption)" />
        </SfNumericTextBox>
    </div>
    <div class="input-group mb-3">
        <SfNumericTextBox TValue="int?" @bind-Value="_travel.ElapsedMinutes"
                          Placeholder="Time (minutes)"
                          FloatLabelType="@FloatLabelType.Auto">
            <ValidationMessage For="@(()=>_travel.ElapsedMinutes)" />
        </SfNumericTextBox>
    </div>
    <div class="input-group mb-3">
        <SfNumericTextBox TValue="decimal?" @bind-Value="_travel.Temperature"
                          Placeholder="Temperature (°C)"
                          FloatLabelType="@FloatLabelType.Auto">
            <ValidationMessage For="@(()=>_travel.Temperature)" />
        </SfNumericTextBox>
    </div>
    <div class="input-group mb-3">
        <SfButton HtmlAttributes="@addTripAttributes" Content="Add trip" IsPrimary="true" />
    </div>
</EditForm>
<SfToast Title="Travel logging"
         Content="@ToastContent"
         Timeout="5000"
         ShowCloseButton="true"
         ShowProgressBar="true"
         @ref="@toastObj">
    <ToastPosition X="Right" Y="Bottom"></ToastPosition>
</SfToast>
<p class="validation-message">
    * A leg of a trip is considered another part of a longer trip.<br />
    This is particularly useful if you wish to charge during a longer trip, but you want to log each trips individually.<br />
    Ex: Kona doesn't reset the Drive Info upon charging, while Tesla shows this information.<br />
    Thus, Kona drivers would make use of the leg travel log, while Tesla drivers should log without leg travel
</p>